#!/bin/sh

CVSROOT=~/cvsroot
RPMROOT=~/rpm
ROOT=~/snapshot
DIR="firestorm-snapshot"
TAG="HEAD"

## export from CVS and cd into root
mkdir -p $ROOT
cvs -d $CVSROOT export -r $TAG -d $ROOT/$DIR firestorm
pushd $ROOT/$DIR

## Setup the source code
aclocal
autoheader
automake -c -a --gnu
libtoolize --automake -c -f
autoconf

## Make the source tarball
cd ..
tar -zcf $DIR.tar.gz $DIR && echo "Snapshot OK"

rm -rf $DIR
popd
