#ifndef __DECODE_HEADER_INCLUDED__
#define __DECODE_HEADER_INCLUDED__

#define PROTO_LEN 15

typedef unsigned int proto_id_t;

struct proto_child {
	struct proto_child	*next;
	proto_id_t		id;
	struct proto		*proto;
};

#define proto_request(x, y) {x, y}
#define null_request() {NULL, 0}
struct proto_req {
	char			*name;
	proto_id_t		id;
};

#ifndef __PLUGIN__
/* temporary structure used internally */
struct preq_list {
	struct preq_list	*next;
	struct proto		*proto;
	struct proto_req	*arr;
};
#endif

#define init_proto(x,y,z)        {NULL, NULL, x   , y   , z   , NULL, NULL, NULL, 0, 0, 0}
#define init_proto2(x,y,z,a,b)   {NULL, NULL, x   , y   , z   , a   , b   , NULL, 0, 0, 0}
#define init_sproto(x,y,z,a,b,c) {NULL, NULL, x   , y   , z   , a   , b   , NULL, 0, 0, c}
#define null_proto()             {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0}
typedef void (*proc_decode)(struct packet *);
typedef int  (*proc_dprint)(struct layer*, char *, int);
typedef void (*proc_sig_match)(struct packet *, unsigned int);
typedef int  (*proc_sig_add)(struct rule *);
struct proto {
	struct proto		*next;
	struct proto_child	*children;

	/* Obvious stuff */
	const char		*name;
	proc_decode		decode;

	/* print out a one line summary given a header */
	proc_dprint		print;

	/* signature engine */
	proc_sig_match		sig_match;
	proc_sig_add		sig_add;

	/* preprocessors */
	struct pp_active	*preproc;
	unsigned int		num_active;
	unsigned int		max_active;

	/* Stream reassembly stuff */
#define PSF_REQUEST		(1<<0)
#define PSF_REPLY		(1<<1)
	u_int32_t		sflags;
};

#ifndef __PLUGIN__
void decode_init(void);
int decode_resolve(struct proto_req *, struct proto *);
int decode_resolve_all(void);
#endif

#ifndef __PLUGIN__
int decode_add(struct proto *, struct proto_req *);
struct proto *decode_proto(char *);
struct proto *decode_subproto(char *, unsigned int);
#else
typedef int(*proc_decode_add)(struct proto *, struct proto_req *);
typedef struct proto *(*proc_decode_proto)(char *);
typedef struct proto *(*proc_decode_subproto)(char *, unsigned int);
#endif

extern struct proto pcap_dlt_p;

#endif /* __DECODE_HEADER_INCLUDED__ */
